# -*- coding: utf-8 -*-
#
# Copyright European Organization for Nuclear Research (CERN)
# All rights reserved
#
# Please look at the supplied documentation for the user's
# license
#
# Author: Vasilis.Vlachoudis@cern.ch
# Date:   8-Feb-2019

__author__ = "Vasilis Vlachoudis"
__email__  = "Vasilis.Vlachoudis@cern.ch"

__all__ = [ "inputConvert" ]

from .convert import conversionClass
from .fluka2moira import Fluka2Moira	 # needed to execute register

#-------------------------------------------------------------------------------
# input conversion method that converts one type to another, based
# on the registered converters
#-------------------------------------------------------------------------------
def inputConvert(inp, mode, defines=None):
	if mode in ("",inp.mode):
		newinp = inp.clone()
		newinp.enableDefines(defines)
		return newinp
	class_ = conversionClass(inp.mode, mode)
	return class_(inp, defines).convert()

#	# ----------------------------------------------------------------------
#	# Convert input file to mode
#	# ----------------------------------------------------------------------
#	def convertTo(self, mode):
#		if mode==self.mode or mode=="":
#			return self.clone()
#		if mode=="moira":
#			return self.convert2Moira()
#		elif mode=="fluka":
#			return self.convert2Fluka()
#		elif mode=="mcnp":
#			return self.convert2Mcnp()
#		else:
#			return None
#
#	# ----------------------------------------------------------------------
#	def convert2Moira(self):
#		return None
#
#	# ----------------------------------------------------------------------
#	def convert2Fluka(self):
#		return None
#
#	# ----------------------------------------------------------------------
#	def convert2Mcnp(self):
#		return None
