# -*- coding: utf-8 -*-
#
# Copyright European Organization for Nuclear Research (CERN)
# All rights reserved
#
# Please look at the supplied documentation for the user's
# license
#
# Import once to initialize all codes
#
# Author: Vasilis.Vlachoudis@cern.ch
# Date:   13-Jun-2006

import Global
import deck
import fluka
import moira
#import penelope

ALL_EXTS  =	(fluka.Fluka.EXT,
		moira.Moira.EXT, moira.Moira.EXTMAC, moira.Moira.EXTMAC2,
#		penelope.Penelope.EXT
		)

EXT2MODE = {
		fluka.Fluka.EXT       : fluka.Fluka.MODE,
		".fluka"              : fluka.Fluka.MODE,
		moira.Moira.EXT       : moira.Moira.MODE,
		moira.Moira.EXTMAC    : moira.Moira.MODE,
		moira.Moira.EXTMAC2   : moira.Moira.MODE,
#		penelope.Penelope.EXT : penelope.Penelope.MODE,
	}

MODE2EXT = {
		fluka.Fluka.MODE       : (fluka.Fluka.EXT),
		moira.Moira.MODE       : (moira.Moira.EXT, moira.Moira.EXTMAC),
#		penelope.Penelope.MODE : penelope.Penelope.EXT,
}

MODE2INPUT = {
		fluka.Fluka.MODE       : fluka.Fluka,
		moira.Moira.MODE       : moira.Moira,
#		penelope.Penelope.MODE : penelope.Penelope,
	}

MODE2CARD = {
		fluka.Fluka.MODE       : fluka.FlukaCard,
		moira.Moira.MODE       : moira.MoiraCard,
#		penelope.Penelope.MODE : penelope.PenelopeCard,
	}

MODE2CONFIG = {
		fluka.Fluka.MODE       : fluka.FlukaConfig,
		moira.Moira.MODE       : moira.MoiraConfig,
#		penelope.Penelope.MODE : penelope.PenelopeConfig,
	}

#-------------------------------------------------------------------------------
# Initialize all CardInfo
#-------------------------------------------------------------------------------
def init():
	deck.init()
	fluka.init()
	if Global.developer:
		moira.init()
		#penelope.init()

	deck.CardInfo.post_init()
	fluka.FlukaCardInfo.post_init()

	if Global.developer:
		moira.MoiraCardInfo.post_init()
		#penelope.PenelopeCardInfo.post_init()
#init()
