# -*- coding: utf-8 -*-
#
# Copyright European Organization for Nuclear Research (CERN)
# All rights reserved
#
# Please look at the supplied documentation for the user's
# license
#
# Author: Vasilis.Vlachoudis@cern.ch
# Date:   9-Nov-2018

__author__ = "Vasilis Vlachoudis"
__email__  = "Vasilis.Vlachoudis@cern.ch"

#from deck import CardInfo
from deck.layout import Layout

from .card import PenelopeCard
from .input import Penelope

#===============================================================================
# Layout class for the specific input/canvas display
#===============================================================================
class PenelopeLayout(Layout):
	MODE = PenelopeCard.MODE

	# ----------------------------------------------------------------------
	def init(self):
		order = [
			#("STAB",      None),
			#("MATERIAL", _MATERIAL_layout),
			("BODY"    , _BODY_layout  ),
		]
		self._init_set(order, Penelope.MODE)

	# ----------------------------------------------------------------------
	# Enable/disable caching of lists
	# ----------------------------------------------------------------------
	def cache(self, on):
		super().cache(on)
		if on:
			self._cache["material"] = self.materialList()
			self._cacheTypedef()

	# ----------------------------------------------------------------------
	# Automatically detect type from range
	# ----------------------------------------------------------------------
	#def iType(self, name, rng):
	#	try:
	#		if rng=="volume":
	#			return (name, StabLayout.volumeList)
	#		else:
	#			return super().iType(name,rng)
	#	except (TypeError,IndexError):
	#		return name

#================================ Geometry Cards ===============================
##---------------------------------- MATERIAL -----------------------------------
#def _MATERIAL_layout(card):
#	layout = [ Layout.name,
#		   ("Density", 1),
#		   ("n", (2, list(range(60))), "Number of components")]
#	n = max(card.intWhat(2), (card.nwhats()-3)//2)
#	for i in range(n):
#		layout.append(Layout.newline)
#		layout.append(Layout.tab)
#		layout.append(("Mat.%02d"%(i+1), (2*i+3, Layout.materialList)))
#		layout.append(("f.%02d"%(i+1),   2*i+4))
#	return layout

#---------------------------------- BODY----------------------------------------
_BODY_layout =  [
		(None,		0),
		("Mat",		(2, Layout.materialList)),
		Layout.newline,
		("expr", -1) ]
